/*! \file */
/*******************************************
 *                                         *
 *  File auto-generated by `::safer_ffi`.  *
 *                                         *
 *  Do not manually edit this file.        *
 *                                         *
 *******************************************/

#ifndef __RUST_MONETAE_FFI__
#define __RUST_MONETAE_FFI__

#ifdef __cplusplus
extern "C"
{
#endif

    typedef struct CWallet CWallet_t;

#include <stddef.h>
#include <stdint.h>

    /** \brief
     *  Same as [`Vec<T>`][`rust::Vec`], but with guaranteed `#[repr(C)]` layout
     */
    typedef struct Vec_uint8
    {

        uint8_t *ptr;

        size_t len;

        size_t cap;

    } Vec_uint8_t;

    typedef struct CPacket
    {

        Vec_uint8_t inner;

    } CPacket_t;

    typedef struct CProxy CProxy_t;

    /** \brief
     *  Return a proxy instance
     */
    CProxy_t *proxy_connect(
        CWallet_t const *wallet,
        Vec_uint8_t endpoints,
        void (*cb)(CPacket_t));

    /** \brief
     *  Send a packet to the gateway via the proxy
     */
    void proxy_send(
        CProxy_t const *proxy,
        CPacket_t packet);

    /** \brief
     *  Disconnect from the proxy and abort the background threads
     */
    void proxy_disconnect(
        CProxy_t const *proxy);

    /** \brief
     *  `&'lt [T]` but with a guaranteed `#[repr(C)]` layout.
     *
     *  # C layout (for some given type T)
     *
     *  ```c
     *  typedef struct {
     *      // Cannot be NULL
     *      T * ptr;
     *      size_t len;
     *  } slice_T;
     *  ```
     *
     *  # Nullable pointer?
     *
     *  If you want to support the above typedef, but where the `ptr` field is
     *  allowed to be `NULL` (with the contents of `len` then being undefined)
     *  use the `Option< slice_ptr<_> >` type.
     */
    typedef struct slice_ref_uint8
    {

        uint8_t const *ptr;

        size_t len;

    } slice_ref_uint8_t;

    /** \brief
     *  Return a wallet instance from a 32 bytes seed
     */
    CWallet_t *wallet_from_seed(
        slice_ref_uint8_t seed);

    /** \brief
     *  Return the wallet verifier key
     */
    slice_ref_uint8_t wallet_verifier(
        CWallet_t const *wallet);

    /** \brief
     *  Return the wallet verifier key
     */
    Vec_uint8_t wallet_sign(
        CWallet_t const *wallet,
        slice_ref_uint8_t payload);

#include <stdbool.h>

    /** \brief
     *  Verify a signature provided a verifier key
     */
    bool wallet_verify_ed25519(
        slice_ref_uint8_t verifier,
        slice_ref_uint8_t payload,
        slice_ref_uint8_t signature);

    typedef struct CRawPromissory
    {

        slice_ref_uint8_t data;

    } CRawPromissory_t;

    /** \brief
     *  return a non-zero error if the authorized promissory verification failed
     */
    int32_t verify_authorized_promissory(
        CRawPromissory_t promissory);

    /** \brief
     *  return a non-zero error if the transferred promissory verification failed
     */
    int32_t verify_transferred_promissory(
        CRawPromissory_t promissory);

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* __RUST_MONETAE_FFI__ */
