import 'dart:ffi' as ffi;
import 'dart:typed_data';
import 'package:ffi/ffi.dart';
import 'dart:convert';

import "./monetae_ffi.dart";

ffi.Pointer<slice_ref_uint8_t> uint8ListToSliceUint8Pointer(Uint8List data) {
  final _ptr =
      malloc.allocate<ffi.Uint8>(ffi.sizeOf<ffi.Uint8>() * data.length);
  for (var i = 0; i < data.length; i++) {
    _ptr.elementAt(i).value = data[i];
  }

  ffi.Pointer<slice_ref_uint8_t> ptr = malloc<slice_ref_uint8_t>();

  ptr.ref.ptr = _ptr;
  ptr.ref.len = data.length;

  return ptr;
}

Uint8List uint8SliceToUint8List(slice_ref_uint8_t data) {
  final list = Uint8List(data.len);
  for (var i = 0; i < data.len; i++) {
    list[i] = data.ptr.elementAt(i).value;
  }
  return list;
}

ffi.Pointer<Vec_uint8_t> uint8ListToVecUint8Pointer(Uint8List data) {
  final _ptr =
      malloc.allocate<ffi.Uint8>(ffi.sizeOf<ffi.Uint8>() * data.length);
  for (var i = 0; i < data.length; i++) {
    _ptr.elementAt(i).value = data[i];
  }

  ffi.Pointer<Vec_uint8_t> ptr = malloc<Vec_uint8_t>();

  ptr.ref.ptr = _ptr;
  ptr.ref.len = data.length;

  return ptr;
}

Uint8List vecUint8ToUint8List(Vec_uint8_t data) {
  final list = Uint8List(data.len);
  for (var i = 0; i < data.len; i++) {
    list[i] = data.ptr.elementAt(i).value;
  }
  return list;
}
